Index: c/src/libnetworking/.cvsignore
===================================================================
--- c/src/libnetworking/.cvsignore	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/.cvsignore	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -1,14 +1,2 @@
-aclocal.m4
-autom4te*.cache
-config.cache
-config.guess
-config.log
-config.status
-config.sub
-configure
-depcomp
-install-sh
 Makefile
 Makefile.in
-missing
-mkinstalldirs
Index: c/src/libnetworking/ChangeLog
===================================================================
--- c/src/libnetworking/ChangeLog	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/ChangeLog	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -1,2 +1,10 @@
+2003-07-25	Ralf Corsepius <corsepiu@faw.uni-ulm.de>
+
+	* configure.ac: Remove (Merged into ../configure.ac).
+	* .cvsignore, Makefile.am, pppd/Makefile.am,
+	rtems_servers/Makefile.am, rtems_telnetd/Makefile.am,
+	rtems_webserver/Makefile.am, wrapup/Makefile.am:
+	Reflect having merged configure.ac into ../configure.ac
+
 2003-06-13	Joel Sherrill <joel@OARcorp.com>
 
Index: c/src/libnetworking/Makefile.am
===================================================================
--- c/src/libnetworking/Makefile.am	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/Makefile.am	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -3,8 +3,6 @@
 ##
 
-ACLOCAL_AMFLAGS = -I ../../../aclocal
-
 SUBDIRS = rtems_servers pppd rtems_telnetd rtems_webserver wrapup
 
-include $(top_srcdir)/../../../automake/subdirs.am
-include $(top_srcdir)/../../../automake/local.am
+include $(top_srcdir)/../../automake/subdirs.am
+include $(top_srcdir)/../../automake/local.am
Index: c/src/libnetworking/configure.ac
===================================================================
--- c/src/libnetworking/configure.ac	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ 	(revision )
@@ -1,43 +1,0 @@
-## Process this file with autoconf to produce a configure script.
-## 
-## $Id$
-
-AC_PREREQ(2.57)
-AC_INIT([rtems-c-src-libnetworking],[_RTEMS_VERSION],[rtems-bugs@OARcorp.com])
-AC_CONFIG_SRCDIR([pppd])
-RTEMS_TOP(../../..)
-
-RTEMS_CANONICAL_TARGET_CPU
-
-AM_INIT_AUTOMAKE([no-define foreign 1.7.2])
-AM_MAINTAINER_MODE
-
-RTEMS_ENABLE_NETWORKING
-RTEMS_ENABLE_BARE
-RTEMS_ENABLE_POSIX
-
-RTEMS_ENV_RTEMSBSP
-
-RTEMS_CHECK_CPU
-RTEMS_CANONICAL_HOST
-
-RTEMS_PROJECT_ROOT
-
-RTEMS_PROG_CC_FOR_TARGET
-RTEMS_CANONICALIZE_TOOLS
-
-RTEMS_CHECK_CUSTOM_BSP(RTEMS_BSP)
-RTEMS_CHECK_NETWORKING(RTEMS_BSP)
-RTEMS_CHECK_POSIX_API(RTEMS_BSP)
-
-AM_CONDITIONAL(HAS_POSIX,test "$HAS_POSIX_API" = "yes")
-
-# Explicitly list all Makefiles here
-AC_CONFIG_FILES([Makefile
-pppd/Makefile
-rtems_servers/Makefile
-rtems_telnetd/Makefile
-rtems_webserver/Makefile
-wrapup/Makefile
-])
-AC_OUTPUT
Index: c/src/libnetworking/pppd/Makefile.am
===================================================================
--- c/src/libnetworking/pppd/Makefile.am	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/pppd/Makefile.am	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -11,6 +11,6 @@
 OBJS = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
-include $(top_srcdir)/../../../automake/compile.am
-include $(top_srcdir)/../../../automake/lib.am
+include $(top_srcdir)/../../automake/compile.am
+include $(top_srcdir)/../../automake/lib.am
 
 #
@@ -18,8 +18,12 @@
 #
 
+if HAS_NETWORKING
+include_HEADERS = rtemspppd.h rtemsdialer.h
+
 $(LIB): $(OBJS)
 	$(make-library)
 
 all-local: $(PREINSTALL_FILES) $(ARCH) $(OBJS) $(LIB)
+endif
 
 .PRECIOUS: $(LIB)
@@ -31,7 +35,4 @@
 rtemspppd.h sys-rtems.c upap.c upap.h utils.c
 
-include_HEADERS = rtemspppd.h rtemsdialer.h
-
-
 PREINSTALL_FILES = $(PROJECT_INCLUDE) $(include_HEADERS:%=$(PROJECT_INCLUDE)/%)
 
@@ -39,3 +40,3 @@
 	$(INSTALL_DATA) $< $@
 
-include $(top_srcdir)/../../../automake/local.am
+include $(top_srcdir)/../../automake/local.am
Index: c/src/libnetworking/rtems_servers/Makefile.am
===================================================================
--- c/src/libnetworking/rtems_servers/Makefile.am	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/rtems_servers/Makefile.am	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -2,6 +2,4 @@
 ## $Id$
 ##
-
-include_rtemsdir = $(includedir)/rtems
 
 LIBNAME = lib.a
@@ -11,6 +9,6 @@
 OBJS = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
-include $(top_srcdir)/../../../automake/compile.am
-include $(top_srcdir)/../../../automake/lib.am
+include $(top_srcdir)/../../automake/compile.am
+include $(top_srcdir)/../../automake/lib.am
 
 #
@@ -18,16 +16,20 @@
 #
 
+EXTRA_DIST = ftpd.c ftpd.h
+
+if HAS_NETWORKING
+include_rtemsdir = $(includedir)/rtems
+
+include_HEADERS = ftpd.h
+
+include_rtems_HEADERS =
+
 $(LIB): $(OBJS)
 	$(make-library)
 
 all-local: $(PREINSTALL_FILES) $(ARCH) $(OBJS) $(LIB)
+endif
 
 .PRECIOUS: $(LIB)
-
-EXTRA_DIST = ftpd.c ftpd.h
-
-include_HEADERS = ftpd.h
-
-include_rtems_HEADERS =
 
 PREINSTALL_FILES = $(PROJECT_INCLUDE) \
@@ -42,3 +44,3 @@
 	$(INSTALL_DATA) $< $@
 
-include $(top_srcdir)/../../../automake/local.am
+include $(top_srcdir)/../../automake/local.am
Index: c/src/libnetworking/rtems_telnetd/Makefile.am
===================================================================
--- c/src/libnetworking/rtems_telnetd/Makefile.am	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/rtems_telnetd/Makefile.am	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -3,5 +3,4 @@
 ##
 
-include_rtemsdir = $(includedir)/rtems
 
 LIBNAME = libtelnetd-tmp
@@ -11,8 +10,7 @@
 OBJS = $(C_FILES:%.c=$(ARCH)/%.$(OBJEXT))
 
-include_rtems_HEADERS = pty.h telnetd.h
 
-include $(top_srcdir)/../../../automake/compile.am
-include $(top_srcdir)/../../../automake/lib.am
+include $(top_srcdir)/../../automake/compile.am
+include $(top_srcdir)/../../automake/lib.am
 
 $(PROJECT_INCLUDE)/rtems:
@@ -25,4 +23,8 @@
 #
 
+if HAS_NETWORKING
+include_rtemsdir = $(includedir)/rtems
+include_rtems_HEADERS = pty.h telnetd.h
+
 $(LIB): $(OBJS)
 	$(make-library)
@@ -32,4 +34,5 @@
 
 all-local: $(ARCH) $(PREINSTALL_FILES) $(OBJS) $(LIB)
+endif
 
 .PRECIOUS: $(LIB)
@@ -37,3 +40,3 @@
 EXTRA_DIST = README pty.c telnetd.c pty.h icmds.c telnetd.h
 
-include $(top_srcdir)/../../../automake/local.am
+include $(top_srcdir)/../../automake/local.am
Index: c/src/libnetworking/rtems_webserver/Makefile.am
===================================================================
--- c/src/libnetworking/rtems_webserver/Makefile.am	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/rtems_webserver/Makefile.am	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -2,6 +2,4 @@
 ## $Id$
 ##
-
-include_goaheaddir = $(includedir)/goahead
 
 LIBNAME = lib.a
@@ -16,6 +14,6 @@
 H_FILES = ej.h ejIntrn.h emfdb.h md5.h uemf.h um.h webs.h wsIntrn.h
 
-include $(top_srcdir)/../../../automake/compile.am
-include $(top_srcdir)/../../../automake/lib.am
+include $(top_srcdir)/../../automake/compile.am
+include $(top_srcdir)/../../automake/lib.am
 
 #
@@ -43,9 +41,13 @@
     $(PROJECT_INCLUDE)/goahead $(H_FILES:%.h=$(PROJECT_INCLUDE)/goahead/%.h)
 
+if HAS_NETWORKING
 if HAS_POSIX
+include_goaheaddir = $(includedir)/goahead
+
 include_HEADERS = rtems_webserver.h
 include_goahead_HEADERS = $(H_FILES)
 
 all-local: $(PREINSTALL_FILES) $(ARCH) $(OBJS) $(LIB)
+endif
 endif
 
@@ -57,3 +59,3 @@
     webmain.c webpage.c webrom.c webs.c webs.h websuemf.c wsIntrn.h
 
-include $(top_srcdir)/../../../automake/local.am
+include $(top_srcdir)/../../automake/local.am
Index: c/src/libnetworking/wrapup/Makefile.am
===================================================================
--- c/src/libnetworking/wrapup/Makefile.am	(revision ad543c7bcea9d6cca6aa74104ddb73194396c442)
+++ c/src/libnetworking/wrapup/Makefile.am	(revision 4078e82ae544f8eec4fcfa05aeb1bf38e3c40099)
@@ -13,6 +13,6 @@
 LIB = $(ARCH)/libnetapps.a
 
-include $(top_srcdir)/../../../automake/compile.am
-include $(top_srcdir)/../../../automake/lib.am
+include $(top_srcdir)/../../automake/compile.am
+include $(top_srcdir)/../../automake/lib.am
 
 #
@@ -20,8 +20,10 @@
 #
 
+if HAS_NETWORKING
 $(LIB): $(OBJS)
 	$(make-library)
 
 all-local: $(ARCH) $(OBJS) $(LIB)
+endif
 
-include $(top_srcdir)/../../../automake/local.am
+include $(top_srcdir)/../../automake/local.am