Index: make/custom/armulator.cfg
===================================================================
--- make/custom/armulator.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/armulator.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -20,5 +20,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 define make-exe
Index: make/custom/av5282.cfg
===================================================================
--- make/custom/av5282.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/av5282.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -17,5 +17,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V= -O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 ifndef MTARGET
Index: make/custom/bare.cfg
===================================================================
--- make/custom/bare.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/bare.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -17,5 +17,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # this target has no start file
Index: make/custom/c3xsim.cfg
===================================================================
--- make/custom/c3xsim.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/c3xsim.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -15,6 +15,6 @@
 # optimize flag: typically -O2
 # -O2 is broken for the moment on the C4x gcc
-#CFLAGS_OPTIMIZE_V=-O2 
-CFLAGS_OPTIMIZE_V=-O1
+#CFLAGS_OPTIMIZE_V = -O2 
+CFLAGS_OPTIMIZE_V = -O1
 
 # this target has no start file
Index: make/custom/c4xsim.cfg
===================================================================
--- make/custom/c4xsim.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/c4xsim.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -15,6 +15,6 @@
 # optimize flag: typically -O2
 # -O2 is broken for the moment on the C4x gcc
-#CFLAGS_OPTIMIZE_V=-O2 
-CFLAGS_OPTIMIZE_V=-O1
+#CFLAGS_OPTIMIZE_V = -O2 
+CFLAGS_OPTIMIZE_V = -O1
 
 # this target has no start file
Index: make/custom/csb336.cfg
===================================================================
--- make/custom/csb336.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/csb336.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 define make-exe
Index: make/custom/csb337.cfg
===================================================================
--- make/custom/csb337.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/csb337.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2 -g 
+CFLAGS_OPTIMIZE_V = -O2 -g 
 
 
Index: make/custom/csb350.cfg
===================================================================
--- make/custom/csb350.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/csb350.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -20,5 +20,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2 -g
+CFLAGS_OPTIMIZE_V = -O2 -g
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/csb360.cfg
===================================================================
--- make/custom/csb360.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/csb360.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -23,5 +23,5 @@
 # It looks like any optimization level > 0 causes problems 
 # with gcc-3.4.0. Until they are fixed, we'll use -O0
-CFLAGS_OPTIMIZE_V=-O0 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O0 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/dmv152.cfg
===================================================================
--- make/custom/dmv152.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/dmv152.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -21,5 +21,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # Here is the rule to actually build a $(ARCH)/foo.exe
Index: make/custom/eZKit533.cfg
===================================================================
--- make/custom/eZKit533.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/eZKit533.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -20,5 +20,5 @@
 # optimize flag: typically -O2
 # gcc-4.2.0 segfaults on -OX > -O0
-CFLAGS_OPTIMIZE_V=-O0
+CFLAGS_OPTIMIZE_V = -O0
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/edb7312.cfg
===================================================================
--- make/custom/edb7312.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/edb7312.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 define make-exe
Index: make/custom/erc32.cfg
===================================================================
--- make/custom/erc32.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/erc32.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -17,5 +17,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/erc32nfp.cfg
===================================================================
--- make/custom/erc32nfp.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/erc32nfp.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -18,5 +18,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/gba.cfg
===================================================================
--- make/custom/gba.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gba.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -20,6 +20,6 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
-CXXFLAGS_OPTIMIZE_V=-O3
+CFLAGS_OPTIMIZE_V = -O2
+CXXFLAGS_OPTIMIZE_V = -O3
 
 define make-exe
Index: make/custom/gen405.cfg
===================================================================
--- make/custom/gen405.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gen405.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -27,5 +27,5 @@
 # optimize flag: typically -O2
 # NOTE: some level of -O may be actually required by inline assembler
-CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions -g
+CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions -g
 
 
Index: make/custom/gen5200.cfg
===================================================================
--- make/custom/gen5200.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gen5200.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -21,5 +21,5 @@
 # optimize flag: typically -O2
 # NOTE: some level of -O may be actually required by inline assembler
-CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions -g
+CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions -g
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/gen68302.cfg
===================================================================
--- make/custom/gen68302.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gen68302.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -22,5 +22,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/gen68340.cfg
===================================================================
--- make/custom/gen68340.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gen68340.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -17,5 +17,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/gen68360.cfg
===================================================================
--- make/custom/gen68360.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gen68360.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -28,5 +28,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/genmongoosev.cfg
===================================================================
--- make/custom/genmongoosev.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/genmongoosev.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2 -g
+CFLAGS_OPTIMIZE_V = -O2 -g
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/gp32.cfg
===================================================================
--- make/custom/gp32.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/gp32.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V= -O2
+CFLAGS_OPTIMIZE_V = -O2
 
 define make-exe
Index: make/custom/h8sim.cfg
===================================================================
--- make/custom/h8sim.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/h8sim.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,6 +19,6 @@
 
 # optimize flag: typically -O2
-# CFLAGS_OPTIMIZE_V=-O4 -mleaf-procedures
-CFLAGS_OPTIMIZE_V=-O0
+# CFLAGS_OPTIMIZE_V = -O4 -mleaf-procedures
+CFLAGS_OPTIMIZE_V = -O0
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/helas403.cfg
===================================================================
--- make/custom/helas403.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/helas403.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -21,5 +21,5 @@
 # optimize flag: typically -O2
 # NOTE: some level of -O may be actually required by inline assembler
-CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions
+CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions
 
 # No start file
Index: make/custom/hurricane.cfg
===================================================================
--- make/custom/hurricane.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/hurricane.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -17,5 +17,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/i386ex.cfg
===================================================================
--- make/custom/i386ex.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/i386ex.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4
+CFLAGS_OPTIMIZE_V = -O4
 
 #  Something like this should produce a map file but this does not work.
Index: make/custom/idp.cfg
===================================================================
--- make/custom/idp.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/idp.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/jmr3904.cfg
===================================================================
--- make/custom/jmr3904.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/jmr3904.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -22,5 +22,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/leon2.cfg
===================================================================
--- make/custom/leon2.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/leon2.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -22,5 +22,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/leon3.cfg
===================================================================
--- make/custom/leon3.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/leon3.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -24,5 +24,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mbx821_002b.cfg
===================================================================
--- make/custom/mbx821_002b.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mbx821_002b.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -13,3 +13,3 @@
 include $(RTEMS_ROOT)/make/custom/mbx8xx.cfg
 
-CFLAGS_OPTIMIZE_V=-O2
+CFLAGS_OPTIMIZE_V = -O2
Index: make/custom/mbx8xx.cfg
===================================================================
--- make/custom/mbx8xx.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mbx8xx.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -49,7 +49,7 @@
 # optimize flag: typically -O, could use -O4 or -fast
 # NOTE: some level of -O may be actually required by inline assembler
-# CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions
-CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions
-CXXFLAGS_OPTIMIZE_V=-O4
+# CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions
+CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions
+CXXFLAGS_OPTIMIZE_V = -O4
 
 define make-exe
Index: make/custom/mcf5206elite.cfg
===================================================================
--- make/custom/mcf5206elite.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mcf5206elite.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -21,5 +21,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mcf5235.cfg
===================================================================
--- make/custom/mcf5235.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mcf5235.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -23,5 +23,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V= -O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 
Index: make/custom/mcp750.cfg
===================================================================
--- make/custom/mcp750.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mcp750.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -19,5 +19,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -mmultiple -mstring -mstrict-align
+CFLAGS_OPTIMIZE_V = -O4 -mmultiple -mstring -mstrict-align
 
 define make-exe
Index: make/custom/mpc8260ads.cfg
===================================================================
--- make/custom/mpc8260ads.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mpc8260ads.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -22,5 +22,5 @@
 # optimize flag: typically -O2
 # NOTE: some level of -O may be actually required by inline assembler
-CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions -g
+CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions -g
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mrm332.cfg
===================================================================
--- make/custom/mrm332.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mrm332.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -18,5 +18,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mtx603e.cfg
===================================================================
--- make/custom/mtx603e.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mtx603e.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -18,5 +18,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -mmultiple -mstring -mstrict-align
+CFLAGS_OPTIMIZE_V = -O4 -mmultiple -mstring -mstrict-align
 
 define make-exe
Index: make/custom/mvme136.cfg
===================================================================
--- make/custom/mvme136.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme136.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -20,5 +20,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mvme147.cfg
===================================================================
--- make/custom/mvme147.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme147.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -17,5 +17,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mvme162.cfg
===================================================================
--- make/custom/mvme162.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme162.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -22,5 +22,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mvme162lx.cfg
===================================================================
--- make/custom/mvme162lx.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme162lx.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -28,5 +28,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as
Index: make/custom/mvme167.cfg
===================================================================
--- make/custom/mvme167.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme167.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -26,5 +26,5 @@
 
 # optimize flag: typically -O, could use -O4 or -fast
-CFLAGS_OPTIMIZE_V=-O4 -fno-omit-frame-pointer
+CFLAGS_OPTIMIZE_V = -O4 -fno-omit-frame-pointer
 
 # Here is the rule to actually build a $(ARCH)/foo.exe
Index: make/custom/mvme2100.cfg
===================================================================
--- make/custom/mvme2100.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme2100.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -18,5 +18,5 @@
 
 # optimize flag: typically -O2
-CFLAGS_OPTIMIZE_V=-O4 -mmultiple -mstring -mstrict-align
+CFLAGS_OPTIMIZE_V = -O4 -mmultiple -mstring -mstrict-align
 
 define make-exe
Index: make/custom/mvme2307.cfg
===================================================================
--- make/custom/mvme2307.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme2307.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -21,5 +21,5 @@
 # optimize flag: typically -O2
 # NOTE: some level of -O may be actually required by inline assembler
-#CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions
+#CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions
 CFLAGS_OPTIMIZE_V = -O4
 
Index: make/custom/mvme5500.cfg
===================================================================
--- make/custom/mvme5500.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/mvme5500.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -21,5 +21,5 @@
 
 # optimize flag: typically -O2
-#CFLAGS_OPTIMIZE_V=-O4 -fno-keep-inline-functions
+#CFLAGS_OPTIMIZE_V = -O4 -fno-keep-inline-functions
 CFLAGS_OPTIMIZE_V = -O4
 
Index: make/custom/nios2_iss.cfg
===================================================================
--- make/custom/nios2_iss.cfg	(revision b1ad6d3384a6304146e67397be3debb13ff3afa0)
+++ make/custom/nios2_iss.cfg	(revision 4233e1f382311ad45ee6b06df4a3bfe602fe9756)
@@ -24,7 +24,7 @@
 
 # GCC-4.0 (ATM, doesn't work with optimization levels > 0):
-# CFLAGS_OPTIMIZE_V= -O0 -fomit-frame-pointer
-CFLAGS_OPTIMIZE_V=-g -O0
-# CFLAGS_OPTIMIZE_V= -O4 -fomit-frame-pointer
+# CFLAGS_OPTIMIZE_V = -O0 -fomit-frame-pointer
+CFLAGS_OPTIMIZE_V = -g -O0
+# CFLAGS_OPTIMIZE_V = -O4 -fomit-frame-pointer
 
 # The following are definitions of make-exe which will work using ld as