Index: cpukit/score/include/rtems/score/atomic.h
===================================================================
--- cpukit/score/include/rtems/score/atomic.h	(revision 2bbcb644f9785a5aa66aa5252905b903f857fdec)
+++ cpukit/score/include/rtems/score/atomic.h	(revision 4288f9fd01f57ff7711bb3d1c4fe22f6ff463980)
@@ -45,5 +45,5 @@
  * @param value a value to be stored into object.
  */
-RTEMS_INLINE_ROUTINE void _Atomic_Init_uint(
+static inline void _Atomic_Init_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value
@@ -53,5 +53,5 @@
 }
 
-RTEMS_INLINE_ROUTINE void _Atomic_Init_ptr(
+static inline void _Atomic_Init_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value
@@ -61,5 +61,5 @@
 }
 
-RTEMS_INLINE_ROUTINE void _Atomic_Init_flag(
+static inline void _Atomic_Init_flag(
   volatile Atomic_Flag *object,
   _Bool value
@@ -77,5 +77,5 @@
  * The order shall not be ATOMIC_ORDER_RELEASE.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _Atomic_Load_uint(
+static inline uint_fast32_t _Atomic_Load_uint(
   volatile Atomic_Uint *object,
   Atomic_Order order
@@ -85,5 +85,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _Atomic_Load_ptr(
+static inline uintptr_t _Atomic_Load_ptr(
   volatile Atomic_Pointer *object,
   Atomic_Order order
@@ -102,5 +102,5 @@
  * The order shall not be ATOMIC_ORDER_ACQUIRE.
  */
-RTEMS_INLINE_ROUTINE void _Atomic_Store_uint(
+static inline void _Atomic_Store_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -111,5 +111,5 @@
 }
 
-RTEMS_INLINE_ROUTINE void _Atomic_Store_ptr(
+static inline void _Atomic_Store_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -129,5 +129,5 @@
  * @retval a result value before add ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _Atomic_Fetch_add_uint(
+static inline uint_fast32_t _Atomic_Fetch_add_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -138,5 +138,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _Atomic_Fetch_add_ptr(
+static inline uintptr_t _Atomic_Fetch_add_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -156,5 +156,5 @@
  * @retval a result value before sub ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _Atomic_Fetch_sub_uint(
+static inline uint_fast32_t _Atomic_Fetch_sub_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -165,5 +165,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _Atomic_Fetch_sub_ptr(
+static inline uintptr_t _Atomic_Fetch_sub_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -183,5 +183,5 @@
  * @retval a result value before or ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _Atomic_Fetch_or_uint(
+static inline uint_fast32_t _Atomic_Fetch_or_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -192,5 +192,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _Atomic_Fetch_or_ptr(
+static inline uintptr_t _Atomic_Fetch_or_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -210,5 +210,5 @@
  * @retval a result value before and ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _Atomic_Fetch_and_uint(
+static inline uint_fast32_t _Atomic_Fetch_and_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -219,5 +219,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _Atomic_Fetch_and_ptr(
+static inline uintptr_t _Atomic_Fetch_and_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -237,5 +237,5 @@
  * @retval a result value before exchange ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _Atomic_Exchange_uint(
+static inline uint_fast32_t _Atomic_Exchange_uint(
  volatile Atomic_Uint *object,
  uint_fast32_t value,
@@ -246,5 +246,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _Atomic_Exchange_ptr(
+static inline uintptr_t _Atomic_Exchange_ptr(
  volatile Atomic_Pointer *object,
  uintptr_t value,
@@ -269,5 +269,5 @@
  * @retval false if the compare exchange failed.
  */
-RTEMS_INLINE_ROUTINE bool _Atomic_Compare_exchange_uint(
+static inline bool _Atomic_Compare_exchange_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t *old_value,
@@ -281,5 +281,5 @@
 }
 
-RTEMS_INLINE_ROUTINE bool _Atomic_Compare_exchange_ptr(
+static inline bool _Atomic_Compare_exchange_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t *old_value,
@@ -300,5 +300,5 @@
  * 
  */
-RTEMS_INLINE_ROUTINE void _Atomic_Clear_flag(
+static inline void _Atomic_Clear_flag(
  volatile Atomic_Flag *object,
  Atomic_Order order
@@ -317,5 +317,5 @@
  * @retval false if the test and set failed.
  */
-RTEMS_INLINE_ROUTINE bool _Atomic_Test_set_flag(
+static inline bool _Atomic_Test_set_flag(
  volatile Atomic_Flag *object,
  Atomic_Order order
Index: cpukit/score/include/rtems/score/cpustdatomic.h
===================================================================
--- cpukit/score/include/rtems/score/cpustdatomic.h	(revision 2bbcb644f9785a5aa66aa5252905b903f857fdec)
+++ cpukit/score/include/rtems/score/cpustdatomic.h	(revision 4288f9fd01f57ff7711bb3d1c4fe22f6ff463980)
@@ -20,5 +20,5 @@
 
 #include <stdatomic.h>
-#include <rtems/score/types.h>
+#include <stdbool.h>
 
 #ifdef __cplusplus
@@ -82,5 +82,5 @@
  * @param value a value to be stored into object.
  */
-RTEMS_INLINE_ROUTINE void _CPU_atomic_Init_uint(
+static inline void _CPU_atomic_Init_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value
@@ -90,5 +90,5 @@
 }
 
-RTEMS_INLINE_ROUTINE void _CPU_atomic_Init_ptr(
+static inline void _CPU_atomic_Init_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value
@@ -98,5 +98,5 @@
 }
 
-RTEMS_INLINE_ROUTINE void _CPU_atomic_Init_flag(
+static inline void _CPU_atomic_Init_flag(
   volatile Atomic_Flag *object,
   _Bool value
@@ -114,5 +114,5 @@
  * The order shall not be ATOMIC_ORDER_RELEASE.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _CPU_atomic_Load_uint(
+static inline uint_fast32_t _CPU_atomic_Load_uint(
   volatile Atomic_Uint *object,
   Atomic_Order order
@@ -122,5 +122,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _CPU_atomic_Load_ptr(
+static inline uintptr_t _CPU_atomic_Load_ptr(
   volatile Atomic_Pointer *object,
   Atomic_Order order
@@ -139,5 +139,5 @@
  * The order shall not be ATOMIC_ORDER_ACQUIRE.
  */
-RTEMS_INLINE_ROUTINE void _CPU_atomic_Store_uint(
+static inline void _CPU_atomic_Store_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -148,5 +148,5 @@
 }
 
-RTEMS_INLINE_ROUTINE void _CPU_atomic_Store_ptr(
+static inline void _CPU_atomic_Store_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -166,5 +166,5 @@
  * @retval a result value before add ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _CPU_atomic_Fetch_add_uint(
+static inline uint_fast32_t _CPU_atomic_Fetch_add_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -175,5 +175,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _CPU_atomic_Fetch_add_ptr(
+static inline uintptr_t _CPU_atomic_Fetch_add_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -193,5 +193,5 @@
  * @retval a result value before sub ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _CPU_atomic_Fetch_sub_uint(
+static inline uint_fast32_t _CPU_atomic_Fetch_sub_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -202,5 +202,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _CPU_atomic_Fetch_sub_ptr(
+static inline uintptr_t _CPU_atomic_Fetch_sub_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -220,5 +220,5 @@
  * @retval a result value before or ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _CPU_atomic_Fetch_or_uint(
+static inline uint_fast32_t _CPU_atomic_Fetch_or_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -229,5 +229,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _CPU_atomic_Fetch_or_ptr(
+static inline uintptr_t _CPU_atomic_Fetch_or_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -247,5 +247,5 @@
  * @retval a result value before and ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _CPU_atomic_Fetch_and_uint(
+static inline uint_fast32_t _CPU_atomic_Fetch_and_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t value,
@@ -256,5 +256,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _CPU_atomic_Fetch_and_ptr(
+static inline uintptr_t _CPU_atomic_Fetch_and_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t value,
@@ -274,5 +274,5 @@
  * @retval a result value before exchange ops.
  */
-RTEMS_INLINE_ROUTINE uint_fast32_t _CPU_atomic_Exchange_uint(
+static inline uint_fast32_t _CPU_atomic_Exchange_uint(
  volatile Atomic_Uint *object,
  uint_fast32_t value,
@@ -283,5 +283,5 @@
 }
 
-RTEMS_INLINE_ROUTINE uintptr_t _CPU_atomic_Exchange_ptr(
+static inline uintptr_t _CPU_atomic_Exchange_ptr(
  volatile Atomic_Pointer *object,
  uintptr_t value,
@@ -306,5 +306,5 @@
  * @retval false if the compare exchange failed.
  */
-RTEMS_INLINE_ROUTINE bool _CPU_atomic_Compare_exchange_uint(
+static inline bool _CPU_atomic_Compare_exchange_uint(
   volatile Atomic_Uint *object,
   uint_fast32_t *old_value,
@@ -318,5 +318,5 @@
 }
 
-RTEMS_INLINE_ROUTINE bool _CPU_atomic_Compare_exchange_ptr(
+static inline bool _CPU_atomic_Compare_exchange_ptr(
   volatile Atomic_Pointer *object,
   uintptr_t *old_value,
@@ -337,5 +337,5 @@
  * 
  */
-RTEMS_INLINE_ROUTINE void _CPU_atomic_Clear_flag(
+static inline void _CPU_atomic_Clear_flag(
  volatile Atomic_Flag *object,
  Atomic_Order order
@@ -354,5 +354,5 @@
  * @retval false if the test and set failed.
  */
-RTEMS_INLINE_ROUTINE bool _CPU_atomic_Test_set_flag(
+static inline bool _CPU_atomic_Test_set_flag(
  volatile Atomic_Flag *object,
  Atomic_Order order